git@vger.kernel.org mailing list mirror (one of many)
 help / color / mirror / code / Atom feed
* [PATCH] fetch: pass --no-write-fetch-head to subprocesses
@ 2023-03-08 10:04 Eric Wong
  2023-03-08 17:41 ` Junio C Hamano
  2023-03-09  3:09 ` [PATCH] " Jeff King
  0 siblings, 2 replies; 8+ messages in thread
From: Eric Wong @ 2023-03-08 10:04 UTC (permalink / raw)
  To: git

It seems a user would expect this option would work regardless
of whether it's fetching from a single remote or many.

Signed-off-by: Eric Wong <e@80x24.org>
---
 I haven't checked if there's other suitable options which could
 go into add_options_to_argv(); hopefully someone else can check :>

 builtin/fetch.c           | 2 ++
 t/t5514-fetch-multiple.sh | 7 +++++++
 2 files changed, 9 insertions(+)

diff --git a/builtin/fetch.c b/builtin/fetch.c
index a09606b472..78513f1708 100644
--- a/builtin/fetch.c
+++ b/builtin/fetch.c
@@ -1880,6 +1880,8 @@ static void add_options_to_argv(struct strvec *argv)
 		strvec_push(argv, "--ipv4");
 	else if (family == TRANSPORT_FAMILY_IPV6)
 		strvec_push(argv, "--ipv6");
+	if (!write_fetch_head)
+		strvec_push(argv, "--no-write-fetch-head");
 }
 
 /* Fetch multiple remotes in parallel */
diff --git a/t/t5514-fetch-multiple.sh b/t/t5514-fetch-multiple.sh
index 54f422ced3..98f034aa77 100755
--- a/t/t5514-fetch-multiple.sh
+++ b/t/t5514-fetch-multiple.sh
@@ -58,6 +58,13 @@ test_expect_success 'git fetch --all' '
 	 test_cmp expect output)
 '
 
+test_expect_success 'git fetch --all --no-write-fetch-head' '
+	(cd test &&
+	rm -f .git/FETCH_HEAD &&
+	git fetch --all --no-write-fetch-head &&
+	test_path_is_missing .git/FETCH_HEAD)
+'
+
 test_expect_success 'git fetch --all should continue if a remote has errors' '
 	(git clone one test2 &&
 	 cd test2 &&

^ permalink raw reply related	[flat|nested] 8+ messages in thread

* Re: [PATCH] fetch: pass --no-write-fetch-head to subprocesses
  2023-03-08 10:04 [PATCH] fetch: pass --no-write-fetch-head to subprocesses Eric Wong
@ 2023-03-08 17:41 ` Junio C Hamano
  2023-03-08 22:22   ` [PATCH v2] " Eric Wong
  2023-03-09  3:09 ` [PATCH] " Jeff King
  1 sibling, 1 reply; 8+ messages in thread
From: Junio C Hamano @ 2023-03-08 17:41 UTC (permalink / raw)
  To: Eric Wong; +Cc: git

Eric Wong <e@80x24.org> writes:

> Subject: Re: [PATCH] fetch: pass --no-write-fetch-head to subprocesses

I read the title as saying that "git fetch --recurse-submodules
--no-write-fetch-head" should propagate the latter option down to
fetches done in submodules, but looking at the added test, you are
addressing a different use case, aren't you?  Or are you covering
both "fetch: honor --no-write-fetch-head when fetching from multiple
remotes" and "fetch: pass --no-write-fetch-head down to submodules"?

> It seems a user would expect this option would work regardless
> of whether it's fetching from a single remote or many.

This hints that it is only the latter, but if we are covering both

 (1) the title we have here may be alright.

 (2) the proposed log message should state the change affects both
     (in a good way).

 (3) the other half may want to be tested in new test as well.

Thanks.

> Signed-off-by: Eric Wong <e@80x24.org>
> ---
>  I haven't checked if there's other suitable options which could
>  go into add_options_to_argv(); hopefully someone else can check :>
>
>  builtin/fetch.c           | 2 ++
>  t/t5514-fetch-multiple.sh | 7 +++++++
>  2 files changed, 9 insertions(+)
>
> diff --git a/builtin/fetch.c b/builtin/fetch.c
> index a09606b472..78513f1708 100644
> --- a/builtin/fetch.c
> +++ b/builtin/fetch.c
> @@ -1880,6 +1880,8 @@ static void add_options_to_argv(struct strvec *argv)
>  		strvec_push(argv, "--ipv4");
>  	else if (family == TRANSPORT_FAMILY_IPV6)
>  		strvec_push(argv, "--ipv6");
> +	if (!write_fetch_head)
> +		strvec_push(argv, "--no-write-fetch-head");
>  }
>  
>  /* Fetch multiple remotes in parallel */
> diff --git a/t/t5514-fetch-multiple.sh b/t/t5514-fetch-multiple.sh
> index 54f422ced3..98f034aa77 100755
> --- a/t/t5514-fetch-multiple.sh
> +++ b/t/t5514-fetch-multiple.sh
> @@ -58,6 +58,13 @@ test_expect_success 'git fetch --all' '
>  	 test_cmp expect output)
>  '
>  
> +test_expect_success 'git fetch --all --no-write-fetch-head' '
> +	(cd test &&
> +	rm -f .git/FETCH_HEAD &&
> +	git fetch --all --no-write-fetch-head &&
> +	test_path_is_missing .git/FETCH_HEAD)
> +'
> +
>  test_expect_success 'git fetch --all should continue if a remote has errors' '
>  	(git clone one test2 &&
>  	 cd test2 &&

^ permalink raw reply	[flat|nested] 8+ messages in thread

* [PATCH v2] fetch: pass --no-write-fetch-head to subprocesses
  2023-03-08 17:41 ` Junio C Hamano
@ 2023-03-08 22:22   ` Eric Wong
  2023-03-08 23:13     ` Junio C Hamano
  0 siblings, 1 reply; 8+ messages in thread
From: Eric Wong @ 2023-03-08 22:22 UTC (permalink / raw)
  To: Junio C Hamano; +Cc: git

Junio C Hamano <gitster@pobox.com> wrote:
> Eric Wong <e@80x24.org> writes:
> 
> > Subject: Re: [PATCH] fetch: pass --no-write-fetch-head to subprocesses
> 
> I read the title as saying that "git fetch --recurse-submodules
> --no-write-fetch-head" should propagate the latter option down to
> fetches done in submodules, but looking at the added test, you are
> addressing a different use case, aren't you?  Or are you covering
> both "fetch: honor --no-write-fetch-head when fetching from multiple
> remotes" and "fetch: pass --no-write-fetch-head down to submodules"?

Just multiple remotes, I hardly deal with submodules.

> > It seems a user would expect this option would work regardless
> > of whether it's fetching from a single remote or many.
> 
> This hints that it is only the latter, but if we are covering both
> 
>  (1) the title we have here may be alright.

Yes, I figured so.  I actually considered just using the title
and didn't really feel the need to add a message body

>  (2) the proposed log message should state the change affects both
>      (in a good way).

Updated.

>  (3) the other half may want to be tested in new test as well.

OK, updated t5526, hope it's portable.  I mimicked the
formatting style of each respective test so the diff itself
looks odd between changes to t5514 and t5526 :x

> Thanks.

v2: revised commit message body, test submodules in t5526
---8<---
Subject: [PATCH] fetch: pass --no-write-fetch-head to subprocesses

It seems a user would expect this option would work regardless
of whether it's fetching from a single remote, many remotes,
or recursing into submodules.

Signed-off-by: Eric Wong <e@80x24.org>
---
 builtin/fetch.c             |  2 ++
 t/t5514-fetch-multiple.sh   |  7 +++++++
 t/t5526-fetch-submodules.sh | 13 +++++++++++++
 3 files changed, 22 insertions(+)

diff --git a/builtin/fetch.c b/builtin/fetch.c
index a09606b472..78513f1708 100644
--- a/builtin/fetch.c
+++ b/builtin/fetch.c
@@ -1880,6 +1880,8 @@ static void add_options_to_argv(struct strvec *argv)
 		strvec_push(argv, "--ipv4");
 	else if (family == TRANSPORT_FAMILY_IPV6)
 		strvec_push(argv, "--ipv6");
+	if (!write_fetch_head)
+		strvec_push(argv, "--no-write-fetch-head");
 }
 
 /* Fetch multiple remotes in parallel */
diff --git a/t/t5514-fetch-multiple.sh b/t/t5514-fetch-multiple.sh
index 54f422ced3..98f034aa77 100755
--- a/t/t5514-fetch-multiple.sh
+++ b/t/t5514-fetch-multiple.sh
@@ -58,6 +58,13 @@ test_expect_success 'git fetch --all' '
 	 test_cmp expect output)
 '
 
+test_expect_success 'git fetch --all --no-write-fetch-head' '
+	(cd test &&
+	rm -f .git/FETCH_HEAD &&
+	git fetch --all --no-write-fetch-head &&
+	test_path_is_missing .git/FETCH_HEAD)
+'
+
 test_expect_success 'git fetch --all should continue if a remote has errors' '
 	(git clone one test2 &&
 	 cd test2 &&
diff --git a/t/t5526-fetch-submodules.sh b/t/t5526-fetch-submodules.sh
index b9546ef8e5..8ffb300f2d 100755
--- a/t/t5526-fetch-submodules.sh
+++ b/t/t5526-fetch-submodules.sh
@@ -167,6 +167,19 @@ test_expect_success "fetch --recurse-submodules recurses into submodules" '
 	verify_fetch_result actual.err
 '
 
+test_expect_success "fetch --recurse-submodules honors --no-write-fetch-head" '
+	(
+		cd downstream &&
+		fh=$(find . -name FETCH_HEAD -type f) &&
+		rm -f $fh &&
+		git fetch --recurse-submodules --no-write-fetch-head &&
+		for f in $fh
+		do
+			test_path_is_missing $f || return 1
+		done
+	)
+'
+
 test_expect_success "submodule.recurse option triggers recursive fetch" '
 	add_submodule_commits &&
 	(

^ permalink raw reply related	[flat|nested] 8+ messages in thread

* Re: [PATCH v2] fetch: pass --no-write-fetch-head to subprocesses
  2023-03-08 22:22   ` [PATCH v2] " Eric Wong
@ 2023-03-08 23:13     ` Junio C Hamano
  2023-03-08 23:40       ` Junio C Hamano
  0 siblings, 1 reply; 8+ messages in thread
From: Junio C Hamano @ 2023-03-08 23:13 UTC (permalink / raw)
  To: Eric Wong; +Cc: git

Eric Wong <e@80x24.org> writes:

> +test_expect_success 'git fetch --all --no-write-fetch-head' '
> +	(cd test &&
> +	rm -f .git/FETCH_HEAD &&
> +	git fetch --all --no-write-fetch-head &&
> +	test_path_is_missing .git/FETCH_HEAD)
> +'

The style used in the other script might be more modern, but given
that the existing one (in the post context) uses the same older
style, I think that would be OK.

>  test_expect_success 'git fetch --all should continue if a remote has errors' '
>  	(git clone one test2 &&
>  	 cd test2 &&
> diff --git a/t/t5526-fetch-submodules.sh b/t/t5526-fetch-submodules.sh
> index b9546ef8e5..8ffb300f2d 100755
> --- a/t/t5526-fetch-submodules.sh
> +++ b/t/t5526-fetch-submodules.sh
> @@ -167,6 +167,19 @@ test_expect_success "fetch --recurse-submodules recurses into submodules" '
>  	verify_fetch_result actual.err
>  '
>  
> +test_expect_success "fetch --recurse-submodules honors --no-write-fetch-head" '
> +	(
> +		cd downstream &&
> +		fh=$(find . -name FETCH_HEAD -type f) &&
> +		rm -f $fh &&

I do not like this part.  The "rm -f" we saw in the "fetch --all" test
was "make sure it is missing, so that we can be sure that presence
after running 'git fetch' *is* a bug".  But using $fh later ...

> +		git fetch --recurse-submodules --no-write-fetch-head &&
> +		for f in $fh
> +		do
> +			test_path_is_missing $f || return 1
> +		done

... like this means now we depend on FETCH_HEAD being in all
submodule repositories before we start this step.

I think we should instead enumerate submodule repositories, instead
of enumerating existing .git/FETCH_HEAD files.

> +	)
> +'
> +
>  test_expect_success "submodule.recurse option triggers recursive fetch" '
>  	add_submodule_commits &&
>  	(

^ permalink raw reply	[flat|nested] 8+ messages in thread

* Re: [PATCH v2] fetch: pass --no-write-fetch-head to subprocesses
  2023-03-08 23:13     ` Junio C Hamano
@ 2023-03-08 23:40       ` Junio C Hamano
  2023-03-08 23:48         ` Eric Wong
  0 siblings, 1 reply; 8+ messages in thread
From: Junio C Hamano @ 2023-03-08 23:40 UTC (permalink / raw)
  To: Eric Wong; +Cc: git

Junio C Hamano <gitster@pobox.com> writes:

> I think we should instead enumerate submodule repositories, instead
> of enumerating existing .git/FETCH_HEAD files.

Perhaps something along this line?

 t/t5526-fetch-submodules.sh | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

diff --git c/t/t5526-fetch-submodules.sh w/t/t5526-fetch-submodules.sh
index 8ffb300f2d..dcdbe26a08 100755
--- c/t/t5526-fetch-submodules.sh
+++ w/t/t5526-fetch-submodules.sh
@@ -170,13 +170,13 @@ test_expect_success "fetch --recurse-submodules recurses into submodules" '
 test_expect_success "fetch --recurse-submodules honors --no-write-fetch-head" '
 	(
 		cd downstream &&
-		fh=$(find . -name FETCH_HEAD -type f) &&
-		rm -f $fh &&
+		git submodule foreach --recursive \
+		sh -c "cd \"\$(git rev-parse --git-dir)\" && rm -f FETCH_HEAD" &&
+
 		git fetch --recurse-submodules --no-write-fetch-head &&
-		for f in $fh
-		do
-			test_path_is_missing $f || return 1
-		done
+
+		git submodule foreach --recursive \
+		sh -c "cd \"\$(git rev-parse --git-dir)\" && ! test -f FETCH_HEAD"
 	)
 '
 

^ permalink raw reply related	[flat|nested] 8+ messages in thread

* Re: [PATCH v2] fetch: pass --no-write-fetch-head to subprocesses
  2023-03-08 23:40       ` Junio C Hamano
@ 2023-03-08 23:48         ` Eric Wong
  2023-03-09 21:32           ` Junio C Hamano
  0 siblings, 1 reply; 8+ messages in thread
From: Eric Wong @ 2023-03-08 23:48 UTC (permalink / raw)
  To: Junio C Hamano; +Cc: git

Junio C Hamano <gitster@pobox.com> wrote:
> Junio C Hamano <gitster@pobox.com> writes:
> 
> > I think we should instead enumerate submodule repositories, instead
> > of enumerating existing .git/FETCH_HEAD files.
> 
> Perhaps something along this line?

Sure, can you squash it into mine?  Thanks.

^ permalink raw reply	[flat|nested] 8+ messages in thread

* Re: [PATCH] fetch: pass --no-write-fetch-head to subprocesses
  2023-03-08 10:04 [PATCH] fetch: pass --no-write-fetch-head to subprocesses Eric Wong
  2023-03-08 17:41 ` Junio C Hamano
@ 2023-03-09  3:09 ` Jeff King
  1 sibling, 0 replies; 8+ messages in thread
From: Jeff King @ 2023-03-09  3:09 UTC (permalink / raw)
  To: Eric Wong; +Cc: git

On Wed, Mar 08, 2023 at 10:04:38AM +0000, Eric Wong wrote:

> It seems a user would expect this option would work regardless
> of whether it's fetching from a single remote or many.
> 
> Signed-off-by: Eric Wong <e@80x24.org>
> ---
>  I haven't checked if there's other suitable options which could
>  go into add_options_to_argv(); hopefully someone else can check :>

There's at least one that came up before:

  https://lore.kernel.org/git/DM5PR1701MB1724CCBB1AC5CF342BA9ADD5898E9@DM5PR1701MB1724.namprd17.prod.outlook.com/

but it never got turned into a real patch.

This is obviously an error-prone mechanism.  It would be nice if there
was a way to avoid it, but after some discussion in this thread, we
didn't come up with anything clever:

  https://lore.kernel.org/git/20200914121906.GD4705@pflmari/

-Peff

^ permalink raw reply	[flat|nested] 8+ messages in thread

* Re: [PATCH v2] fetch: pass --no-write-fetch-head to subprocesses
  2023-03-08 23:48         ` Eric Wong
@ 2023-03-09 21:32           ` Junio C Hamano
  0 siblings, 0 replies; 8+ messages in thread
From: Junio C Hamano @ 2023-03-09 21:32 UTC (permalink / raw)
  To: Eric Wong; +Cc: git

Eric Wong <e@80x24.org> writes:

> Junio C Hamano <gitster@pobox.com> wrote:
>> Junio C Hamano <gitster@pobox.com> writes:
>> 
>> > I think we should instead enumerate submodule repositories, instead
>> > of enumerating existing .git/FETCH_HEAD files.
>> 
>> Perhaps something along this line?
>
> Sure, can you squash it into mine?  Thanks.

Heh, I left it at "something along this line" because I didn't want
to debug it myself, or think about the longer-term ramifications
when the tests before this part eventually change in the future.

I've squashed it in and merged the result to 'next', together with a
few other topics.

Thanks.

^ permalink raw reply	[flat|nested] 8+ messages in thread

end of thread, other threads:[~2023-03-09 21:32 UTC | newest]

Thread overview: 8+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2023-03-08 10:04 [PATCH] fetch: pass --no-write-fetch-head to subprocesses Eric Wong
2023-03-08 17:41 ` Junio C Hamano
2023-03-08 22:22   ` [PATCH v2] " Eric Wong
2023-03-08 23:13     ` Junio C Hamano
2023-03-08 23:40       ` Junio C Hamano
2023-03-08 23:48         ` Eric Wong
2023-03-09 21:32           ` Junio C Hamano
2023-03-09  3:09 ` [PATCH] " Jeff King

Code repositories for project(s) associated with this public inbox

	https://80x24.org/mirrors/git.git

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).